@echo off

rem ---------------
rem making data.bin
rem ---------------

set TRG=setup
echo %TRG%
bcc32 -esup.exe xor_dt.c %TRG%.c xor_dt.c -osup
del sup.tds %TRG%.obj xor_dt.obj

.\sup.exe glorkz data.bin


rem -------------------------
rem compile library
rem -------------------------

set TRG=__sdcc_call_hl
echo %TRG%
sdasz80 -o %TRG%.rel %TRG%.s

set TRG=crtenter
echo %TRG%
sdasz80 -o %TRG%.rel %TRG%.s

set TRG=heap
echo %TRG%
sdasz80 -o %TRG%.rel %TRG%.s

set TRG=mul
echo %TRG%
sdasz80 -o %TRG%.rel %TRG%.s

set TRG1=divunsigned
set TRG2=divsigned
set TRG3=modunsigned
set TRG4=modsigned
echo %TRG1%+%TRG2%+%TRG3%+%TRG4%
sdasz80 -o %TRG1%.rel %TRG1%.s %TRG2%.s %TRG3%.s %TRG4%.s

set TRG=_strlen
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=_strncmp
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=atoi
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=free
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=malloc
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=printf_large
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=puts
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=rand
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=sprintf
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=vprintf
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym


rem -------------------------------
rem compile assembler source for P6
rem -------------------------------

set TRG=crt0
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=data_rd
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=putchar
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=getchar
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=getrreg
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=sec_rdwr
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s

set TRG=ungetcin
echo %TRG%
sdasz80 -o -g %TRG%.rel %TRG%.s


rem --------------------------
rem compile C source for P6
rem --------------------------

set TRG=err
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=file60
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=xor_dt
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym


rem --------------------------
rem compile customize C source
rem --------------------------

set TRG=crc
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=done
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=init
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=io
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=main
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=save
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=subr
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=vocab
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym

set TRG=wizard
echo %TRG%
sdcc -mz80 --opt-code-size -c %TRG%.c
del %TRG%.asm %TRG%.lst %TRG%.sym


rem --------------------------
rem linkall
rem --------------------------

echo link
sdcc -mz80 --no-std-crt0 --nostdlib --nostdinc --code-loc 0x0000 --data-loc 0xb880 crt0.rel data_rd.rel putchar.rel getchar.rel getrreg.rel sec_rdwr.rel ungetcin.rel err.rel file60.rel xor_dt.rel crc.rel done.rel init.rel io.rel main.rel save.rel subr.rel vocab.rel wizard.rel __sdcc_call_hl.rel crtenter.rel heap.rel mul.rel divunsigned.rel _strlen.rel _strncmp.rel atoi.rel free.rel malloc.rel printf_large.rel puts.rel rand.rel sprintf.rel vprintf.rel



rem ---------------------------
rem convert intel-HEX to binary
rem ---------------------------

echo ihx2bin
..\ihx2bin crt0.ihx main.bin -offset 0 -size 47232

copy /b main.bin ..\release_org\SOURCE\
copy /b data.bin ..\release_org\SOURCE\
