/*                          */
/* k8x12 PNG  BMPɕϊ */
/*     pf[^𔲂o */
/*                          */

#define	BYTE_LINE	8
#define	CHAR_LINE	16
#define	SIZE_Y		12
#define	DATST		62+191*BYTE_LINE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void get1line(FILE *infp,int *buf);
void out1char(FILE *outfp,int *buf, int xpos);


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		buf[BYTE_LINE*SIZE_Y];
	int		c;
	int		i,j,k,m;
	int		a0,sft;
	long int	pos;


	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

/* wb_ 0x40 */
	fputc('K', outfp);
	fputc('8', outfp);
	fputc('x', outfp);
	fputc('1', outfp);
	fputc('2', outfp);
	for (i = 5;i < 0x40;i ++) {
		fputc(0x00, outfp);
	}


/* 4x12̂߁A48rbgi6oCgjɎ߂ */


	fseek(infp, DATST - BYTE_LINE*SIZE_Y*2, SEEK_SET);

	for (k = 0;k < 6;k ++) {
		get1line(infp, buf);
		for (i = 0;i < CHAR_LINE;i ++ ) {
			if (k == 5 && i >= 15) {
				break;
			}
			out1char(outfp, buf, i);
		}
	}

/* x^(0x7f) */
	for (i = 0;i < SIZE_Y/2;i ++) {
		fputc(0xff, outfp);
	}

	fseek(infp, DATST - BYTE_LINE*SIZE_Y*10, SEEK_SET);

	for (k = 0;k < 4;k ++) {
		get1line(infp, buf);
		for (i = 0;i < CHAR_LINE;i ++ ) {
			out1char(outfp, buf, i);
		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}


/* P荞 */
void get1line(FILE *infp,int *buf)
{
	int		i,j;
	int		c;

	for (j = 0;j < SIZE_Y; j ++) {
		for (i = 0;i < BYTE_LINE;i ++ ) {
			c = fgetc(infp);
			if (c == EOF) {
				fprintf(stderr, "Data illigal\n");
				exit(1);
			}
			buf[j*BYTE_LINE+i] = c ^ 0xff;	/* rbg] */
		}
		fseek(infp,-BYTE_LINE*2, SEEK_CUR);
	}

	return;
}

/* P̃f[^o͂ */
void out1char(FILE *outfp,int *buf, int xpos)
{
	int		a0,a1;
	int		i;

	if ( (xpos % 2) == 0) {
		for (i = 0;i < SIZE_Y;i += 2) {
			a0= (buf[(i+0)*BYTE_LINE+xpos/2] & 0xf0);
			a1= (buf[(i+1)*BYTE_LINE+xpos/2] & 0xf0) >> 4;
			fputc(a0|a1, outfp);
		}
	} else {
		for (i = 0;i < SIZE_Y;i += 2) {
			a0= (buf[(i+0)*BYTE_LINE+xpos/2] & 0x0f) << 4;
			a1= (buf[(i+1)*BYTE_LINE+xpos/2] & 0x0f);
			fputc(a0|a1, outfp);
		}
	}

	return;

}

