;
; Np
;

	relaxed on

	include "pc60_hira.asm"

Disk_Routine	equ	$bd00
Disk_Init	equ	Disk_Routine+0
Disk_Load	equ	Disk_Routine+3

PAGE_VRAM	equ	$c0

INIT_BIOS	equ	$b018

AD_ARGC		equ	$fff0
AD_ARGV1	equ	$fff8

	org	$f900

;
; Track#0 Sector#1`
;
	db	"SYS"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de		; i[AhX
	call	$4274		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c		; ZN^ԍ
	ld	a,c
	cp	$11
	jr	c,.lp1
	ld	c,$01
	inc	b		; gbNԍ
.lp1:	pop	af
	dec	a
	jr	nz,.loop
	ret

START:
	ld	sp,$ae00

	xor	a		; hCuԍ-1
	ld	(ix+0),a
	ld	(ix+27),a	; G[JEg

;
; Np[`i㔼jǂݍ
;
	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$ae00	; i[AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC

;
; fBXNǂݏ[`ǂݍ
;
	ld	bc,$0004	; BFgbNԍ^CFZN^ԍihCupǂݏo[`j
	ld	a,($fe74)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fdboot_in
	ld	bc,$0007	; BFgbNԍ^CFZN^ԍiOthCupǂݏo[`j
.fdboot_in:
	ld	de,$bd00	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

;
; BIOSǂݍ
;
	ld	bc,$000a	; BFgbNԍ^CFZN^ԍihCupǂݏo[`j
	ld	de,$b000	; i[擪AhX
	ld	a,$07		; ǂݍރZN^
	call	READ_NSEC

	call	INIT_BIOS	; BIOS̏

	di
	call	SET_MAINRAM	; 

;
; ʃNA
;
	ld	hl,PAGE_VRAM*$0100
.lp1:	ld	(hl),$0f
	inc	hl
	ld	a,h
	cp	PAGE_VRAM+$04
	jr	nz,.lp1
.lp2:	ld	(hl),$20
	inc	hl
	ld	a,h
	cp	PAGE_VRAM+$08
	jr	nz,.lp2

	ld	de,VER_MSG
	call	PNT_MSG

	jp	MAIN

VER_MSG:
	db	"Colossal Cave Adventure for P6 ver1.0",$0d,$0d,$00

MAINLD_MSG:
	db	"Loading main program #",$00

MAIN1LD_MSG:
	db	"1...",$0d,$00

MAIN2LD_MSG:
	db	"2...",$0d,$00

KANJILD_MSG:
	db	"Loading kanji font...",$0d,$00

DISKNG_MSG:
	db	"Disk error",$00

RAMNG_MSG:
	db	"64K ", H_i, H_si, "", H_yos, H_u, H_no, "RAM", H_ka, " "
	db	H_hi, H_tu, H_yo, H_u, H_te, "", H_su, "", $0d, $00



	org	$fa00
	phase	$ae00

MAIN:

;
; Nʐݒ
;
	ld	a,$fd		; 160x200 / character / 40x20
	out	($c1),a
	ld	a,$f3
	out	($b0),a		; VRAMAhX=0xc000A^C}荞OFF

;
; u[gpfBXN[`̏
;
	ld	d,$00
	call	Disk_Init	; Init
	jp	c,DISKNG

;
; `FbNi64K̂݁j
;
	call	SET_EXRAM	; O

	ld	hl,$0000
	ld	(hl),$5a
	ld	h,$40
	ld	(hl),$a5
	ld	h,$c0
	ld	c,(hl)
	ld	(hl),$69

	ld	h,$00
	ld	a,(hl)
	cp	$5a
	jp	nz,RAMNG
	ld	h,$40
	ld	a,(hl)
	cp	$a5
	jp	nz,RAMNG
	ld	h,$c0
	ld	a,(hl)
	ld	(hl),c
	cp	$69
	jp	nz,RAMNG

		; CvOǂݍ
		; i$0000`$7fffj
		;
	ld	de,MAINLD_MSG
	call	PNT_MSG
	ld	de,MAIN1LD_MSG
	call	PNT_MSG
	call	SET_EXRAM	; O
	ld	de,$0101	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$0000	; i[AhX
	ld	bc,$8000	; ǂݍރZN^^hCuԍ
	call	DIsk_Load
	jp	c,DISKNG

		; CvOǂݍ
		; i$8000`$bfffj
		; ]p[`ǂݍ
		; i$ff00`$ffffj
		; œ]
		;
	ld	de,MAINLD_MSG
	call	PNT_MSG
	ld	de,MAIN2LD_MSG
	call	PNT_MSG
	call	SET_EXRAM	; O
	ld	de,$0901	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$c000	; i[AhX
	ld	bc,$4000	; ǂݍރZN^^hCuԍ
	call	DIsk_Load
	jp	c,DISKNG


		; tHgǂݍ
		;
	ld	de,KANJILD_MSG
	call	PNT_MSG		; iɁj
	ld	de,$1901	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$0000	; i[AhX
	ld	bc,$a000	; ǂݍރZN^^hCuԍ
	call	DIsk_Load
	jp	c,DISKNG


	ld	a,$ff		; oXNGXgOFF
	out	($c8),a		; iSR̂݁Amk2ɂ̓|[gȂj

;
; VRAMNAiOtBbNj
;
	ld	hl,$c000
.lp1:	ld	(hl),$00
	inc	hl
	ld	a,h
	or	a
	jr	nz,.lp1

	call	SET_EXRAM	; O

;
; ݒ
;
	im	2
	ld	a,$b0
	ld	i,a		; 荞݃e[u0xb000`ɐݒ

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$f1		; 320x200 / graphic / 40x20
	out	($c1),a

	ld	a,$f2
	out	($b0),a		; VRAMAhX=0xC000A^C}荞ON

.col1:	ld	a,$00		; css1-3 = 000
	and	$07
	or	$f8
	out	($c0),a

		;
		; SRǂ|[g0xA3gĔ
		;
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	d,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	e,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	b,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	or	b
	or	d
	or	e
.col2:	jr	z,.nosr

	ld	a,$03		; css1-3 = 011
	and	$07
	or	$f8
	out	($c0),a

				; pbg̐ݒ
	ld	a,$0f ! $0f	; 
	out	($40),a
	out	($41),a
	out	($42),a
	ld	a,$0f ! $08	; 
	out	($43),a

.nosr:

	ld	a,$03
	out	($93),a		; ʂ\

	ld	a,$07
	out	($a0),a		; ~LT[
	ld	a,$bf
	out	($a1),a		; `l`o͂

	ld	a,$08
	out	($a0),a		; `l`
	xor	a
	out	($a1),a

	ld	sp,$ffe0

	jp	$0000

;
; $0000-$3fff,$c000-$ffffORAM
;
SET_EXRAM:
	ld	a,$ed
	out	($f1),a
	ld	a,$ee
	out	($f0),a
	ld	a,$9a
	out	($f2),a
	ret

;
; $0000`$ffffRAM
;
SET_MAINRAM:
	ld	a,$dd
	out	($f1),a
	out	($f0),a
	ld	a,$55
	out	($f2),a
	ret

;
; RAMG[\
;
RAMNG:
	ld	de,RAMNG_MSG
	jp	DISKNG.disp

;
; fBXNG[\
;
DISKNG:
	ld	de,DISKNG_MSG
.disp:	di
	call	PNT_MSG
	jr	$

;
; \
;
PNT_MSG:
	call	SET_MAINRAM
	push	bc
	ld	bc,(CUR_XY)
.lp1:
	ld	a,(de)
	inc	de
	or	a
	jr	z,.end
	cp	$0d
	jr	nz,.nom

	ld	c,0
	inc	b
	jr	.lp1
.nom:
	push	af
	push	bc

	ld	a,b
	add	a,a		; x2
	add	a,a		; x4
	add	a,b		; x5
	ld	l,a
	ld	h,0
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40
	ld	b,PAGE_VRAM+$04	; VRAMy[Wݒ
	add	hl,bc

	pop	bc
	pop	af
	ld	(hl),a
	inc	c

	ld	a,c
	cp	40
	jr	c,.lp1
	ld	c,0
	inc	b
	jr	.lp1

.end:
	ld	(CUR_XY),bc
	pop	bc
	ret

CUR_XY:	dw	$00


	dephase

	org	$fbff
	db	$ff


end

