/*                          */
/* k8x12 PNG  BMPɕϊ */
/*         f[^𔲂o */
/*                          */

#define	BYTE_LINE	96
#define	CHAR_LINE	94
#define	SIZE_Y		12
#define	DATST		62+1127*BYTE_LINE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void get1line(FILE *infp,int *buf);
void out1char(FILE *outfp,int *buf, int xpos);


int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		buf[BYTE_LINE*SIZE_Y];
	int		c;
	int		i,j,k,m;
	int		a0,sft;
	long int	pos;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

/* 8x11̂߁A11oCgɎ߂ */

/* L */
/*  */
/* MVAVA */
	fseek(infp, DATST - BYTE_LINE*SIZE_Y*0, SEEK_SET);

	for (k = 0;k < 7;k ++) {
		get1line(infp, buf);
		for (i = 0;i < CHAR_LINE;i ++ ) {
			out1char(outfp, buf, i);
		}
	}

/* ꐅ */
	fseek(infp, DATST - BYTE_LINE*SIZE_Y*15, SEEK_SET);

	for (k = 0;k < 32;k ++) {
		get1line(infp, buf);
		for (i = 0;i < CHAR_LINE;i ++ ) {
			if (k == 31 && i >= 51) {
				break;
			}
			out1char(outfp, buf, i);
		}
	}

/* 񐅏 (0xE0D6) */
	fseek(infp, DATST - BYTE_LINE*SIZE_Y*63, SEEK_SET);
	get1line(infp, buf);
	out1char(outfp, buf, 55);

/* 񐅏 J(0xE84A) */
	fseek(infp, DATST - BYTE_LINE*SIZE_Y*78, SEEK_SET);
	get1line(infp, buf);
	out1char(outfp, buf, 10);

/* x^ */
	for (i = 0;i < SIZE_Y-1;i ++) {
		fputc(0xff, outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}


/* P荞 */
void get1line(FILE *infp,int *buf)
{
	int		i,j;
	int		c;

	for (j = 0;j < SIZE_Y; j ++) {
		for (i = 0;i < BYTE_LINE;i ++ ) {
			c = fgetc(infp);
			if (c == EOF) {
				fprintf(stderr, "Data illigal\n");
				exit(1);
			}
			buf[j*BYTE_LINE+i] = c ^ 0xff;	/* rbg] */
		}
		fseek(infp,-BYTE_LINE*2, SEEK_CUR);
	}

	return;
}

/* P̃f[^o͂ */
void out1char(FILE *outfp,int *buf, int xpos)
{
	int		a0;

	a0= buf[ 0*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 1*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 2*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 3*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 4*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 5*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 6*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 7*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 8*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[ 9*BYTE_LINE+xpos]; fputc(a0, outfp);
	a0= buf[10*BYTE_LINE+xpos]; fputc(a0, outfp);

/*
	a0= ( (buf[ 0*BYTE_LINE+xpos] & 0xfe)     ) |
		( (buf[ 1*BYTE_LINE+xpos] & 0x80) >> 7) ;
	fputc(a0, outfp);

	a0= ( (buf[ 1*BYTE_LINE+xpos] & 0x7e) << 1) |
		( (buf[ 2*BYTE_LINE+xpos] & 0xc0) >> 6) ;
	fputc(a0, outfp);

	a0= ( (buf[ 2*BYTE_LINE+xpos] & 0x3e) << 2) |
		( (buf[ 3*BYTE_LINE+xpos] & 0xe0) >> 5) ;
	fputc(a0, outfp);

	a0= ( (buf[ 3*BYTE_LINE+xpos] & 0x1e) << 3) |
		( (buf[ 4*BYTE_LINE+xpos] & 0xf0) >> 4) ;
	fputc(a0, outfp);

	a0= ( (buf[ 4*BYTE_LINE+xpos] & 0x0e) << 4) |
		( (buf[ 5*BYTE_LINE+xpos] & 0xf8) >> 3) ;
	fputc(a0, outfp);

	a0= ( (buf[ 5*BYTE_LINE+xpos] & 0x06) << 5) |
		( (buf[ 6*BYTE_LINE+xpos] & 0xfc) >> 2) ;
	fputc(a0, outfp);

	a0= ( (buf[ 6*BYTE_LINE+xpos] & 0x02) << 6) |
		( (buf[ 7*BYTE_LINE+xpos] & 0xfe) >> 1) ;
	fputc(a0, outfp);

	a0= ( (buf[ 8*BYTE_LINE+xpos] & 0xfe)     ) |
		( (buf[ 9*BYTE_LINE+xpos] & 0x80) >> 7) ;
	fputc(a0, outfp);

	a0= ( (buf[ 9*BYTE_LINE+xpos] & 0x7e) << 1) |
		( (buf[10*BYTE_LINE+xpos] & 0xc0) >> 6) ;
	fputc(a0, outfp);

	a0= ( (buf[10*BYTE_LINE+xpos] & 0x3e) << 2) ;
	fputc(a0, outfp);
*/

	return;

}

